#!/usr/local/bin/perl

use warnings;
use strict;

my $line_points = 0;
my $avg;
my $current_line;
my $last_x = 0;
my $last_y = 0;
my $synth_y;
my $synth_x; 
my $delta_x;
my $delta_y;
my $gamma_x;
my $gamma_y;
my $last_hidden = 0;
my $hidden = 0;
my $in_line = 0;
my $output;

if (!($ARGV[0])) { print "usage: perl trim.pl logfile.txt <->[x|y] [value]\n"; exit; }

my $logfile = shift @ARGV;
 
open(LOGFILE, "<$logfile") || die "can't open $logfile!!\n";

my $direction;
my $axis;

$_ = shift @ARGV;
if(m/-/)  {
	$direction = 'lt';
} else {
	$direction = 'gt';
}
if(m/(x|X)/) {
	$axis = 'x';
} else {
	$axis = 'y';
}
my $value = shift @ARGV;

print 'Axis: ' . $axis . '   Direction: ' . $direction . '   Value: ' . $value . "\n";

my $do_output = 0;
my $compare = 0;

while (<LOGFILE>) {
	if (m/ start new map line/) {
		print $output;
		print "--- start new map line ---\n";
		$output = '';
		$in_line = 0;
	} elsif (m/Your location is (.*?\.\d{2}), (.*?\.\d{2}), (.*?\.\d{2}).  Your/) {
        my $x = $1;
        my $y = $3;
        my $z = $2;

        $x =~ s/,//g;
        $y =~ s/,//g;
        $z =~ s/,//g;
        
		if($axis eq 'x') {
			$compare = $x;
			$delta_x = $x - $last_x;                                                 
			$delta_y = $y - $last_y;                                                 																																																						
			$gamma_x = $value - $last_x ;                                            																																																						
			$synth_x = $value;			                                             																																																						
			$synth_y = $last_y + ((abs($delta_x) > .25) ? $delta_y/$delta_x * $gamma_x : 0);																																																						
		} else {
			$compare = $y;
			$delta_x = $x - $last_x;
			$delta_y = $y - $last_y;
			$gamma_y = $value - $last_y ;
			$synth_y = $value;			
			$synth_x = $last_x + ((abs($delta_y) > .25) ? $delta_x/$delta_y * $gamma_y : 0);
		}

		if($direction eq 'gt')  {
			if($compare > $value)  {
				$do_output = 1;
				$hidden = 0;
			} else {
				$hidden = 1;
			}
		} else {
			if($compare < $value)  {
				$do_output = 1;
				$hidden = 0;
			} else {
				$hidden = 1;
			}
		}
		if($do_output)  {
			if($last_hidden == 1 and $hidden == 0 and $in_line == 1)  {  # Going from out of range to in range
				$output .= print "Exiting Hidden\n";
				$output .= sprintf("Synthetic Your location is %0.2f, %0.2f, %0.2f.  Your\n", $synth_x, 0, $synth_y);
			}
			$output .= $_;
			$do_output = 0;
		} else {
			if ($last_hidden == 0 and $hidden == 1) {  # Going from in range to out of range
				$output .= sprintf("Synthetic Your location is %0.2f, %0.2f, %0.2f.  Your\n", $synth_x, 0, $synth_y);
				$output .="--- Synthetic start new map line ---\n";
			}
 		}
		$last_x = $x;
	 	$last_y = $y;
	 	$last_hidden = $hidden;
	 	$in_line = 1;
	} else {
		$output .= $_;
	}
}
print $output;

#print "current $x, $y -- last $last_x, $last_y -- d_y: $delta_y  d_x: $delta_x  g_x: $gamma_x\n";
#print "\nSynthetic start new map line\n";
